
#ifndef __RAND_MERSENNE_H__
#define __RAND_MERSENNE_H__


/******************************************************************************/
/*                                   CONSTANTES                               */
/******************************************************************************/

#if 0
  /* define constants for MT11213A : */
  #define MERS_N   351
  #define MERS_M   175
  #define MERS_R   19
  #define MERS_U   11
  #define MERS_S   7
  #define MERS_T   15
  #define MERS_L   17
  #define MERS_A   0xE4BD75F5
  #define MERS_B   0x655E5280
  #define MERS_C   0xFFD58000
#else
  /* or constants for MT19937 : */
  #define MERS_N   624
  #define MERS_M   397
  #define MERS_R   31
  #define MERS_U   11
  #define MERS_S   7
  #define MERS_T   15
  #define MERS_L   18
  #define MERS_A   0x9908B0DF
  #define MERS_B   0x9D2C5680
  #define MERS_C   0xEFC60000
#endif
#define LOWER_MASK ((1LU<<MERS_R)-1)
#define UPPER_MASK ( -1L<<MERS_R   )


/******************************************************************************/
/*                             TYPE D'ARCHITECTURE                            */
/******************************************************************************/

typedef enum {
  LITTLEENDIAN,
  BIGENDIAN,
  NONIEEE
} architecture_t;


/******************************************************************************/
/*                    CONVERSION DOUBLE <-> UNSIGNED LONG                     */
/******************************************************************************/

typedef union {
  double f;
  unsigned long i[2];
} conversion_t;


/******************************************************************************/
/*                                 PROTOTYPES                                 */
/******************************************************************************/

void rand_init(unsigned long);
double randu(void);


#endif

